#include "windows.h" 
#include "os.h"
#include "time.h"
#include "stdio.h"
#include "string.h"
#include "resource.h"
#include "io.h"
#include "direct.h"

FILE *gFileLog;

//char gszFullPath[512] = "";
char gszFullPathRoot[512] = "";
//char gszShortFile[128] = "";
char gszShortRoot[128] = "";

char gszPreviewText[512] = "";
char gszAppPath[512] = "";
char gszIniFile[512] = "";

char gszVersion[] = "1.0";

typedef char FILENAMESTRING[_MAX_FNAME];

#define MAX_FILES 1024

FILENAMESTRING gaszFiles[MAX_FILES];
int gnNumFiles = 0;

#define DITEM(a) GetDlgItem(hDlg, a)
#define DCHECK(a) IsDlgButtonChecked(hDlg, a)

void vDiagOut(char *lpszFormat,...)
{
	va_list args;
	va_start(args, lpszFormat);

	if (gFileLog) {
		vfprintf(gFileLog, lpszFormat, args);
	}
	vprintf(lpszFormat, args);

	va_end(args);
}

void vInitGlobals(void)
{
	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];

	GetModuleFileName(GetModuleHandle(NULL), gszAppPath, 511);

	_splitpath(gszAppPath, szDrive, szDir, NULL, NULL);

	strcpy(gszAppPath, szDrive);
	strcat(gszAppPath, szDir);

	strcpy(gszIniFile, gszAppPath);
	strcat(gszIniFile, "renumber.ini");

	gnNumFiles = 0;

	//vReadIni();
}

void vTrimToPath(char *szFile)
{
	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];

	_splitpath(szFile, szDrive, szDir, NULL, NULL);

	strcpy(szFile, szDrive);
	strcat(szFile, szDir);
}


char *szTrimExt(char *szFile)
{
	int nLen = strlen(szFile);
	int i;

	for (i = nLen - 1; i >= nLen - 4 && i > 0; --i) {
		if (szFile[i] == '.') {
			szFile[i] = 0;
			break;
		}
	}

	return szFile;
}

BOOL bGetFileSpec(void)
{
	OPENFILENAME ofn;

	static char szFilter[] = "Graphics files (*.BMP;*.A;*.TGA)\0*.bmp;*.a;*.tga\0\0";

	char szFile[512];
	char szFileTitle[128];

	memset(&ofn, 0, sizeof(OPENFILENAME));

	szFile[0] = 0;
	szFileTitle[0] = 0;

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = 511;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = 127;
	ofn.lpstrTitle = "ReNumber: Select a file. All BMP, A and TGA files will be renamed";
	ofn.lpstrDefExt = "txt";

	ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;

	BOOL bRet = GetOpenFileName(&ofn);

	if (bRet) {
		strcpy(gszFullPathRoot, szFile);
		vTrimToPath(gszFullPathRoot);
	}

	return bRet;
}

void vRenumberOne(char *szFile, BOOL bTest)
{
	int nLen = strlen(szFile);
	int i, j;
	int nNewLen = 0;
	int nDigitCount = 0;
	char szNew[_MAX_FNAME];
	char szFinal[_MAX_FNAME];
	BOOL bFoundNonDigit = FALSE;
	BOOL bFoundPeriod = FALSE;

	// strip out underscores & count digits
	for (i = 0; i < nLen; ++i) {
		if (isdigit(szFile[i]) || szFile[i] == '.' || bFoundPeriod) {
			if (szFile[i] == '.') {
				bFoundPeriod = TRUE;
			}
			if (isdigit(szFile[i])) {
				nDigitCount++;
			}
			szNew[nNewLen] = szFile[i];
			nNewLen++;
		} else {
			bFoundNonDigit = TRUE;
		}
	}
	szNew[nNewLen] = 0;

	if (nDigitCount == 11 && !bFoundNonDigit) {
		vDiagOut("%s seems OK. Leaving it alone.\n", szFile);
		return;
	}

	if (nDigitCount < 7) {
		vDiagOut("%s has too few digits to work with safely. Leaving it alone.\n", szFile);
		return;
	}

	if (nDigitCount > 11) {
		vDiagOut("%s has too many digits to work with safely. Leaving it alone.\n", szFile);
		return;
	}

	nLen = 0;
	int nInsertPos = nDigitCount - 7;
	int nNumToInsert = 11 - nDigitCount;
	for (i = 0; i < nNewLen; ++i) {
		szFinal[nLen] = szNew[i];
		nLen++;
		if (i == nInsertPos) {
			for (j = 0; j < nNumToInsert; ++j) {
				szFinal[nLen] = '0';
				nLen++;
			}
		}
	}
	szFinal[nLen] = 0;

	vDiagOut("Renaming %s to %s.\n", szFile, szFinal);

	if (!bTest) {
		rename(szFile, szFinal);
	}
}
		
	



void vRenumberFiles(BOOL bTest)
{
	struct _finddata_t c_file;    
	long hFile;
	int i;

    /* Find first .c file in current directory */
	_chdir(gszFullPathRoot);
	gnNumFiles = 0;

    if((hFile = _findfirst( "*.bmp", &c_file )) != -1L ) {

		strcpy(gaszFiles[gnNumFiles], c_file.name);
		gnNumFiles++;

        /* Find the rest of the files */
        while( _findnext( hFile, &c_file ) == 0 ) {
			
			if (gnNumFiles >= MAX_FILES) {
				vDiagOut("Too many files in directory. Get Don to bump up the #define. Exiting.");
				return;
			}
			strcpy(gaszFiles[gnNumFiles], c_file.name);
			gnNumFiles++;
        }       
		_findclose( hFile ); 
	}
    if((hFile = _findfirst( "*.a", &c_file )) != -1L ) {

		strcpy(gaszFiles[gnNumFiles], c_file.name);
		gnNumFiles++;

        /* Find the rest of the files */
        while( _findnext( hFile, &c_file ) == 0 ) {
			
			if (gnNumFiles >= MAX_FILES) {
				vDiagOut("Too many files in directory. Get Don to bump up the #define. Exiting.");
				return;
			}
			strcpy(gaszFiles[gnNumFiles], c_file.name);
			gnNumFiles++;
        }       
		_findclose( hFile ); 
	}
    if((hFile = _findfirst( "*.tga", &c_file )) != -1L ) {

		strcpy(gaszFiles[gnNumFiles], c_file.name);
		gnNumFiles++;

        /* Find the rest of the files */
        while( _findnext( hFile, &c_file ) == 0 ) {
			
			if (gnNumFiles >= MAX_FILES) {
				vDiagOut("Too many files in directory. Get Don to bump up the #define. Exiting.");
				return;
			}
			strcpy(gaszFiles[gnNumFiles], c_file.name);
			gnNumFiles++;
        }       
		_findclose( hFile ); 
	}

	for (i = 0; i < gnNumFiles; ++i) {
		vRenumberOne(gaszFiles[i], bTest);
	}
}



//"p:\games\vampwar\user\donm\anconv\A_test" -s 10

//int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdParam, int)
int main( int argc, /* Number of strings in array argv */
 char *argv[],       /* Array of command-line argument strings */
 char **envp )       /* Array of environment variable strings */
{
	//char szFilename[512];
	//char szInput[512],
	// szOutput[512],
	// szInputAlpha[512];

	BOOL bTest;

	vInitGlobals();


	gFileLog = fopen("RENUMBER.LOG", "at");

	vDiagOut("----------------------\n");
	vDiagOut("ReNumber Version: %s\n", gszVersion);

	time_t nTime;
	struct tm *pTIME;

	time( &nTime );                 /* Get time in seconds */
	pTIME = localtime( &nTime );  /* Convert time to struct */
										/* tm form */

	/* Print local time as a string */
	vDiagOut("%s\n", asctime(pTIME) );

	if (argc > 1 && strcmp(argv[1], "-t") == 0) {
		bTest = TRUE;
	} else {
		bTest = FALSE;
	}

	while (bGetFileSpec()) {
		vRenumberFiles(bTest);
	}
	if (gFileLog) {
		fclose(gFileLog);
	}
	return 0;
}
