// BARGRAPH.CPP -- the bitmap bargraph code
//
// TW


#include "bargraph.h"

BarGraph::BarGraph(WORD wNewWidth, WORD wNewHeight, int nUpperLimit, BG_DIR eDirection) 
	:Bitmap(wNewWidth, wNewHeight,16) {

	mnMaxLimit = nUpperLimit;
	meDirection = eDirection;
	mnCurLevel = 0;
	mnX = 0;
	mnY = 0;
	mwFillColor = 0;
}



void BarGraph::vFill(int nLevel) {

	// fill with transparency first (using BYTE math)
	int nSize = (DWORD)(wWidthInBytes) * (DWORD)(wHeight);
	memset(mpPixels, 0x0, nSize);
	
	WORD* pixels = (WORD*)mpPixels;
	nLevel = min(nLevel, mnMaxLimit);
	if (nLevel > 0) {
		mnCurLevel = nLevel;
		int i;
		switch (meDirection) {
		case BG_HORIZONTAL:
			{
/* old 8bit way
				int nFillRowPixels = ( wWidthInBytes * nLevel + (mnMaxLimit / 2) ) / mnMaxLimit;
				//loop through each vertical row and fill with just enough(nFillRowPixles) pixels needed
				for (i = 0; i < wHeight; ++i) {
					memset(mpPixels + i * wWidthInBytes, jColor, nFillRowPixels);
				}
*/
				int nFillRowPixels = ( wWidth * nLevel + (mnMaxLimit / 2) ) / mnMaxLimit;
				//loop through each vertical row and fill with just enough(nFillRowPixles) pixels needed
				if (nFillRowPixels) {
					for (i = 0; i < wHeight; ++i) {
						vFillPixels16(pixels + i * wWidth, mwFillColor, nFillRowPixels);
					}
				}
			}
			break;

		case BG_VERTICAL:
			{
				int nRowsToSkip = wHeight - (( wHeight * nLevel + (mnMaxLimit / 2) ) / mnMaxLimit);
				//memset(mpPixels + nRowsToSkip * wWidthInBytes, jColor, nSize - (nRowsToSkip * wWidthInBytes)); //old 8 bit way
				int nFillPixels = wWidth * wHeight - (nRowsToSkip * wWidth);
				if (nFillPixels) {
					vFillPixels16(pixels + nRowsToSkip * wWidth, mwFillColor, nFillPixels);
				}
			}
			break;

		} //switch (mnDirection)
	
	} //nLevel > 0
}

void BarGraph::vSetXY(int nX, int nY) {
	mnX = nX;
	mnY = nY;
}

void BarGraph::vSetFillColor(BYTE jRed, BYTE jGreen, BYTE jBlue)
{
	mwFillColor = (WORD)gpoBlender->dwPack(jRed, jGreen, jBlue);
}