// BARGRAPH.H -- the bitmap bargraph includes
//
// TW
//
// A bar graph object which can be horizontal or vertical in use.
//
// A horizontal bar graph ASSUMES right edge of bar is the maximum value allowed
// and left edge of the bar is 0.
//
// A vertical bar graph ASSUMES top edge of bar is the maximum value allowed
// and bottom edge of the bar is 0.

#ifndef _bargraph_
#define _bargraph_

#include "bitmap.h"

typedef enum _BG_DIR {
	BG_HORIZONTAL,
	BG_VERTICAL,
} BG_DIR;


class BarGraph : public Bitmap {
	public:
		BarGraph(WORD wNewWidth, WORD wNewHeight, int nUpperLimit, BG_DIR eDirection = BG_HORIZONTAL);
		void vFill(int nLevel);
		BG_DIR eBarType() {return meDirection;}
		void vNewUpperLimit(int nNewLimit) {mnMaxLimit = nNewLimit;}
		int nCurLevel() {return mnCurLevel;}
		int nMaxLimit()	{return mnMaxLimit;}
		void vSetFillColor(BYTE jRed, BYTE jGreen, BYTE jBlue);

		//use these functions for whatever you want/need
		void vSetXY(int nX, int nY);
		int nGetX() {return mnX;}
		int nGetY() {return mnY;}
		
	protected:
		int		mnMaxLimit;				//the maximum value the bar can ever be at
		BG_DIR	meDirection;			//horizontal or vertical bar
		int		mnCurLevel;				//the current level the bargraph is at
		
		int		mnX;					//use it for whatever you need/want
		int		mnY;					//use it for whatever you need/want
		WORD	mwFillColor;				//the color used to fill graph
};

#endif // _bargraph_
