#ifndef _guard
#define _guard

#ifndef _os_h
#include "os.h"
#endif

#ifndef _UNIT_
#include "Unit.h"
#endif

typedef enum 
{
	GUARD_READY = 0xAA, 
	GUARD_BUSY, 
	GUARD_RESPONDLATER,
	GUARD_VERIFIED,
	GUARD_NOMESSAGE,
} enumGuardMessage;

typedef struct 
{
	BOOL				bValid;
	enumGuardMessage	eStatus;
} TypeGuardStatus;


const int FORMATIONOFFSETS[48] = 
{	
	5,  0,	4,	1,	4,	2,	
	3,  3,	2,	4,	1,	4,	
	0,	5, -1,	4, -2,	4,
   -3,	3, -4,  2, -4,  1,
   -5,  0, -4, -1, -4, -2,
   -3, -3, -2, -4, -1, -4,
	0, -5,  1, -4,  2, -4,
	3, -3,  4, -2,  4, -1 
};

/*const int FORMATIONOFFSETS[48] = 
{	
	3,	0,	3,	1,	3,	2,	
	3,  3,	2,	3,	1,	3,	
	0,	3, -1,	3, -2,	3,
   -3,	3, -3,  2, -3,  1,
   -3,  0, -3, -1, -3, -2,
   -3, -3, -2, -3, -1, -3,
	0, -3,  1, -3,  2, -3,
	3, -3,  3, -2,  3, -1 
};*/

const int F_POSITIONS[] = 
{ 
	36,
	12,		36,
	42,		30,		12,
	6,		18,		30,		42,		
	8,		16,		30,		36,		42,		
	2,		12,		22,		30,		36,		42,									
	 //6,		12,		18,		 32,		40,
	 //6,		12,		18,		 26,		36,			46,
};

const int F_INDEX[6] = { 0, 1, 3, 6, 10, 15 };

class GuardCoordinator
{

public:
	GuardCoordinator(Unit& moGuardThisUnit):moUnitGuarded(moGuardThisUnit),
		munCountGuards(0), mpoMapNodeTarget(0), mnChecksSinceLastShift(0),
		mnShiftFrequency(64), mbPreparingToMove(FALSE), mnRotation(0), mnDirectionAdjustment(0),
		mpoMapNodeGuardVerify(NULL),mpoUnitPrimary(NULL)
	{
	}

	~GuardCoordinator()
	{
	}
	void GuardCheckedIn(int i, enumGuardMessage eGuardMessage);
	void vAddGuard(Unit *poUnit);
	int  vRemoveGuard(Unit *poUnit);
	void AllGuardsMoveIntoPosition();

	void EveryoneMustCheckIn();

	void Move( MapNode * poMapNodeTarget, BOOL bInterior);
	// guards can respond later
	void Message(Unit *poFromUnit, enumGuardMessage eGuardMessage);
	BOOL EveryoneCheckedIn();
	void LinkFormation();
	void BeginMoveToTarget();
	void Idle();
	void FinishMoveToTarget();
	void PrepareToHalt();
	void CheckingIn();
protected:
	UINT				munCountGuards;
	Unit&				moUnitGuarded;
	RefList<Unit>		moGuards;		// who is guarding this unit ( for formations )
	BOOL				mbReadyToMove;
	TypeGuardStatus		maStatus[100];  // TBD - dynamic more than this please
	MapNode	*			mpoMapNodeTarget;
	MapNode	*			mpoMapNodeGuardVerify;
	Unit *				mpoUnitPrimary;
	void SetTarget( MapNode * poMapNode, BOOL bInterior );
	BOOL GuardsShouldShiftAround();
	int					mnShiftFrequency;
	int					mnChecksSinceLastShift;
	BOOL				mbPreparingToMove;
	int					mnRotation;
	int					mnDirectionAdjustment;
};

#endif
