#ifndef _ITEM_H_
#define _ITEM_H_

typedef enum TAG_ITEM_TYPE
{
	ITEM_RADIANT,
	ITEM_NONRADIANT
} ITEM_TYPE;

class Item : public DrawObj
{
public:
	Item(MapPlane *poPlane, int nTemplateID);
	~Item();

// OVERRIDES
	void vGameCycle();				
	Boolean HandleEvent(sciEvent & oEvent);
	void vCopySelf(sciEvent &oEvent);
	void vInsertSelf(sciEvent &oEvent);

	BOOL bCanSteal();

	int GetInventoryBitmapId();
	const char * GetItemName();

// OWNERSHIP
	void vSetOwner(Player * poNewOwner);
	void vSetOwner(Unit * poNewOwner);
	void vClearOwner();
	void vClearUnitOwner();

	Player * mpoOwner;
	Unit * mpoUnit;

// POWER STONE SPECIFIC
	void CheckNodeForAllies(MapNode * poNode, int nDistance);
	void vScan();
	FLOAT DrainPower(FLOAT fPower);
	virtual void vTakeActionOnNewOwner();

	ITEM_TYPE meType;
	UINT munRange;
	FLOAT mfOwnerPowerGain;
	FLOAT mfMaxPowerGain;
	FLOAT mfMinPowerGain;
	FLOAT mfPowerReservoir;
	int mnChanceToStealIn10000;
};



#endif