// MINIMAP.H -- the minimap
//
// TW
//


#ifndef _minimap_
#define _minimap_

#include "bitmap.h"

class MapScroller;
class MapFrame;

class MiniMap : public Bitmap {
	public:
		MiniMap(WORD wNewWidth, WORD wNewHeight, MapFrame *poPlane, int nZoom);
		~MiniMap();
		void vGameCycle();
		void vErase();
		void vSetPixel(POINT tWhere, WORD wColor);
		void vDraw(int nX, int nY);
		void vForceUpdate();
	protected:
		Boolean		mbForcedUpdate;
		MapFrame	*mpoPlane;
		int			mnCycleUpdate;		//how many game cycles we should rebuild 
		int			mnZoom;				//1=single pixels, 2 = pixel doubling, etc

		WORD		mwBLACK;			//black

		//terrain type colors
		WORD		mwNONE;
		WORD		mwGRASS;
		WORD		mwSAND;
		WORD		mwSNOW;
		WORD		mwOBSTACLE;
		WORD		mwBUILDINGO;
		WORD		mwBUILDINGI;
		WORD		mwTREES;
		WORD		mwSTONE;
		WORD		mwROADS;
		WORD		mwWATER;
		WORD		mwBRIDGE;
		WORD		mwGATE;
		WORD		mwDIRT;

		//player colors
		//WORD		mwPlayer1;
		//WORD		mwPlayer2;
		//WORD		mwPlayer3;
		//WORD		mwPlayer4;
		//WORD		mwPlayer5;
		//WORD		mwPlayer6;
		//WORD		mwPlayer7;
		//WORD		mwPlayer8;
		//WORD		maPlyrColors[8];

		//other colors
		WORD		mwVampireHunter;
		WORD		mwPeasant;

};

#endif // _minimap_
