#ifndef _prf
#define _prf

#include <stdio.h>
#include "object.h"
class SymbolTable;

#ifdef OS_WINDOWS
	#define MAKEC4ID(c1, c2, c3, c4) \
		(long)(((DWORD)c4<<24) + ((DWORD)c3<<16) + ((DWORD)c2<<8) + (DWORD)c1)
#endif // OS_WINDOWS

#ifdef THINK_CPLUS
	#define MAKEC4ID(c1, c2, c3, c4) \
		(long)((c1<<24) + (c2<<16) + (c3<<8) + c4)
#endif
	

// Portable Resource File info.

/*
File Format:

PRF_FILEHEADER
RESOURCES
PRF_RESOURCEDIRECTORY
*/

// All offsets from beginning of file.

/*typedef struct {
	char c1;
	char c2;
	char c3;
	char c4;
	} CHAR4;*/
	
//
typedef long CHAR4;

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
/*typedef enum {
	FALSE,
	TRUE
	} BOOL;
*/

typedef struct {
	WORD 	wByteOrder;	
	CHAR4	c4ID;		// 'P', 'R', 'F', 0x00
	DWORD	dwVersion;
	DWORD	dwFileSize;
	DWORD	dwSizeOfResourceDirectory;
	DWORD	dwResourceDirectoryOffset;
	} PRF_FILEHEADER;

typedef struct {
	CHAR4	c4Type;
	WORD	wID;
	DWORD	dwOffset;
	DWORD	dwLength;		// Including optional description.
	} PRF_RESOURCEMAP;

typedef struct {
	WORD			wNumOfResources;
	WORD			bIncludeDescriptions;
	PRF_RESOURCEMAP	prfResourceMap[1];
	} PRF_RESOURCEDIRECTORY;

class UniHandle;

class PRF : public Object {
	public:
		PRF();
		~PRF();
		void New(char *szFilename);
		void Open(char *szFilename, char *szMode);
		void Add(char *szResourceFilename, CHAR4 c4ResourceType, WORD wId, char *szDescription);
		void Add1(void *pData, size_t dataSize, CHAR4 c4ResourceType, WORD wId, char *szDescription);
		void Remove(CHAR4 c4ResourceType, WORD wID);
		void Load(CHAR4 c4ResourceType, WORD wId, BYTE **data, int *numOfBytes);
		WORD NeedToSwapBytes();

	private:
		void GetFileInfo();
		void WriteHeaders();
		DWORD GetResourceIndex(CHAR4 c4ResourceType, WORD wID);
		void CompactResourceData(DWORD &dwResourceNumber);
		void CompactResourceMap(DWORD &dwResourceNumber, DWORD &dwDeltaOffset);
		void SwapPrfFileHeader();
		void SwapPrfResourceDirectory();

		FILE *pFile;
		PRF_FILEHEADER *pPRFFileHeader;
		PRF_RESOURCEDIRECTORY *pPRFResourceDirectory;

  		WORD fNeedToSwapBytes;
  		SymbolTable *fSymbolTable;
		};

inline WORD PRF::NeedToSwapBytes()
{
	return fNeedToSwapBytes;
}

DWORD filelength(FILE *pFile);


#endif // _prf
