//	PROCS.CPP
//
//


#include "dialog.h"
#include "gamemap.h"
#include "mapplane.h"
#include "mapnode.h"
#include "procs.h"
#include  "unit.h"
#include "colordef.h"

#define MAX_STR_SIZE	33	//includes the null terminator


extern GameMap *gpoMap;
char *poReturnString;


long lCheckTemplate (int nTemplateID, long lTag, long lDefault) {
	Template *poTemplate = (Template*)pApp->pResourceManager->LoadResource(RES_TEMPLATE, nTemplateID);
	assert (poTemplate);

	long lReturnVal = poTemplate->lGetValue(lTag, lDefault);

	pApp->pResourceManager->FreeResource(poTemplate);
	poTemplate = NULL;

	return lReturnVal;
}


Boolean bValidTemplate(int nTemplateID) {
	Template *poTemplate = (Template*)pApp->pResourceManager->LoadResource(RES_TEMPLATE, nTemplateID);
	assert (poTemplate);
	Boolean bResult;

	if (poTemplate->GetData()) {
		bResult = TRUE;
	} else {
		bResult = FALSE;
	}

	pApp->pResourceManager->FreeResource(poTemplate);
	poTemplate = NULL;
	return bResult;
}


Boolean bGetNumber (char *pstrTitleText, int &nNumber, int nSize) {
	char strData[MAX_STR_SIZE];
	memset(strData, 0x0, MAX_STR_SIZE);

	sciEvent oEvent;
	DialogPlane *poDialog = new DialogPlane(pstrTitleText, strData, min(nSize, MAX_STR_SIZE - 1));
	poDialog->vAutoSize();
	poDialog->vSetBGColor(C_DIALOG);
	poDialog->vUpdate();

	bGetInputEvent(&oEvent); //flush out any events that may have gotten us here
	
	while (poDialog->bDone() == FALSE) {
		if (bGetInputEvent(&oEvent) == TRUE) {
			pApp->pWindow->HandleEvent(oEvent);
		}
	}
	
	if (poDialog->bValidData()) {
		delete poDialog;
		poDialog = NULL;
		UINT i;
		for (i = 0; i < strlen(strData); ++ i) {
			if (!isdigit(strData[i])) {
				//there were non-numeric characters entered
				return FALSE;
			}
		}
		nNumber = atoi(strData);
		return TRUE;
	}
	else {
		delete poDialog;
		poDialog = NULL;
		return FALSE;	//we ESC'd or CANCEL'd out 
	}
}


Boolean bGetString (char *pstrTitleText, char *pstrReturnStr, int nSize) {
	sciEvent oEvent;
	DialogPlane *poDialog = new DialogPlane(pstrTitleText, pstrReturnStr, min(nSize, MAX_STR_SIZE - 1));
	poDialog->vAutoSize();
	poDialog->vSetBGColor(C_DIALOG);
	poDialog->vUpdate();

	while (poDialog->bDone() == FALSE) {
		if (bGetInputEvent(&oEvent) == TRUE) {
			pApp->pWindow->HandleEvent(oEvent);
		}
	}
	
	if (poDialog->bValidData()) {
		delete poDialog;
		poDialog = NULL;
		return TRUE;
	}
	else {
		delete poDialog;
		poDialog = NULL;
		return FALSE;	//we ESC'd or CANCEL'd out 
	}

}

void vMessage(char *pstrTitleText) {
	sciEvent oEvent;
	DialogPlane *poDialog = new DialogPlane(pstrTitleText, NULL, 0);
	poDialog->vAutoSize();
	poDialog->vSetBGColor(C_DIALOG);
	poDialog->vUpdate();

	while (poDialog->bDone() == FALSE) {
		if (bGetInputEvent(&oEvent) == TRUE) {
			pApp->pWindow->HandleEvent(oEvent);
		}
	}
	
	delete poDialog;
	poDialog = NULL;

}








