#ifndef _RESMAN_
#define _RESMAN_

#include "resource.h"
#include "list.h"

//class List;
class PRF;

class ResourceNode : public Object
	{
	public:
		Resource *resource;
		int usageCount;
	};

class ResourceManager : public Object
	{
	public:
		ResourceManager(char *prfName = NULL);
		~ResourceManager();
		Resource *LoadResource(RESOURCE_TYPES newType, int newResourceID, Boolean bStop = FALSE);
		void FreeResource(Resource *resource);
		void PurgeResource(Resource *resource);
		void PurgeResources(int bytesCanUse);
		void PreloadResource(RESOURCE_TYPES newType, int newResourceID);
		char *GetName();
		Boolean	bStop() {return mbStop;}

		List<PRF> listOfPRFs;

	private:
		Boolean		mbStop;		//if TRUE, stops program due to resource not found
		ResourceNode *FindNode(RESOURCE_TYPES newType, int newResourceID);
		ResourceNode *FindNode(Resource *resource);

		List<ResourceNode> listOfResources;
		char *name;
	};

#endif
