#include "os.h"
#include "rc.h"
#include "rooms.h"
#include "room0.h"
#include "app.h"
#include "bitmap.h"
#include "window.h"
#include "sciplane.h"
#include "scisound.h"
#include "util.h"
#include "scigame.h"
#include "scitext.h"
#include "scicursr.h"
#include "scicycle.h"
#include "roomcrdt.h"
#include "game.h"

// global
extern HINSTANCE hInstance;
extern Application *pApp;

RoomCredits *roomCredits = NULL;

RoomCredits::RoomCredits()
	{
	game->SetGameName("Credits");
	SetPic(ROOM_CREDITS);
	roomCredits = this;
	}

RoomCredits::~RoomCredits()
	{
	game->SetGameName(NULL);
	}

void RoomCreditsScript::ChangeState(int newState)
	{	
	static int viewNum = 0;
	sciScript::ChangeState(newState);
	switch (state)
		{
		case 0:
			SetTicks(0);
			break;
		case 1: //General Setup
			viewNum = 9100;
			roomCredits->credits->SetView(viewNum);
			roomCredits->credits->Show();
			SetSeconds(4);
			break;
		case 2:
			viewNum++;
			if (viewNum <= 9125)
			{
				roomCredits->credits->SetView(viewNum);
				SetState(1);
				SetSeconds(4);
			}
			else
			{
				SetState(0);
				SetTicks(0);
			}
			break;
		default:
			break;
		}
	}

void RoomCredits::Init()
	{	
	SetMainMenu(CREDITS_MENU);
	
	game->curRoom->plane->cursor->SetHotspot(1, 0);
	game->curRoom->plane->cursor->SetView(5103);
	
	credits = new sciView();
	credits->SetView(9100);
	credits->Posn(0, 0);
	credits->SetPri(10);
	credits->Init();
	credits->Hide();
		
	game->sound1->SetLoop(-1);
	//game->sound1->Play(8178);
	SetScript(new RoomCreditsScript);
	}

Boolean RoomCredits::HandleEvent(sciEvent &event)
	{
	switch (event.type)
		{
		case MOUSE_DOWN:
		case KEY_PRESS:
			game->SetNextRoom(ROOM_0);
			event.claimed = TRUE;
			break;
		}
	return event.claimed;
	}
