#include "os.h"

#include "roomend.h"
#include "app.h"
#include "window.h"
#include "scigame.h"
#include "sciscrip.h"
#include "rc.h"
#include "sigs.h"
#include "game.h"

// globals
extern SIGS *sigs;

RoomEnd::RoomEnd()
{
	if (sigs) {
		delete sigs;
		sigs = NULL;
	}
	SetPic(9999);

	MENUITEMINFO mii;
	mii.cbSize = sizeof(mii);
	mii.fMask = MIIM_STATE;
	mii.fType = 0;
	mii.fState = MFS_GRAYED;
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 0, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 1, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 2, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 3, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 4, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 5, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 6, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 7, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 8, TRUE, &mii);
	SetMenuItemInfo(GetMenu(pApp->pWindow->hWnd), 9, TRUE, &mii);
	DrawMenuBar(pApp->pWindow->hWnd);
}

RoomEnd::~RoomEnd()
{
	if (pApp && pApp->pWindow) {
		pApp->pWindow->Erase(pApp->pWindow->rcInner);
	}
}

class RoomEndScript : public sciScript
{
 public:
	void RoomEndScript::ChangeState(int newState) {
		sciScript::ChangeState(newState);
		switch (state) {
		case 0:
			SetTicks(0);
			break;
		case 1:
			SetSeconds(10);
			break;
		case 2:
			game->QuitGame(TRUE);
			break;
		}
	}
};

void RoomEnd::Init()
{
	sciRoom::Init();
	SetScript(new RoomEndScript);
}

Boolean RoomEnd::HandleEvent(sciEvent & event)
{
	if ((event.type == MOUSE_DOWN) || (event.type == KEY_PRESS))
		script->SetTicks(0);
	return TRUE;
}
