#ifndef _scibtngp
#define _scibtngp

//#include "scilist.h"
#include "list.h"
#include "scichkbx.h"

class sciButtonGroup;

class sciRadioButton : public sciCheckBox
{
	public:
		sciRadioButton(int newID, Boolean newSelected = FALSE);
		~sciRadioButton();
		Boolean HandleEvent(sciEvent &event);	
		int GetID();
		void SetID(int newID);
		void SetButtonGroupList(RefList<sciRadioButton> *newButtonList);
		void vSetButtonGroup(sciButtonGroup *poGroup) {mpoButtonGroup = poGroup;}
		void vSetUnselect(Boolean bCanUnselect) {mbCanUnselect = bCanUnselect;}
		sciButtonGroup *poButtonGroup() {return mpoButtonGroup;}

	protected:
		int buttonID;
		RefList<sciRadioButton> *buttonGroupList;
		sciButtonGroup *mpoButtonGroup;	//backpointer to the group that owns us
		Boolean mbCanUnselect;	//normally you can't unselect a selected radio button, but if 
								//this is TRUE you can
};


class sciButtonGroup : public sciView
{
	public:
		sciButtonGroup();
		~sciButtonGroup();
		
		Boolean AddToGroup(sciRadioButton *newButton);
		sciRadioButton *GetSelectedButton();
		int GetSelectedButtonID();
		void SelectButtonByID(int newID);
		void EnableAll();
		void DisableAll();
		void UnselectAll();
		
		void Show();
		void Hide();
	
	protected:
		RefList<sciRadioButton> *buttonList;

};

class sciTab : public sciRadioButton
{
	public:
		sciTab(int newID, Boolean newSelected = FALSE);
		~sciTab();
		void AddToTab(sciFeature *newFeature);
		void Select();
		void Unselect();
	
	protected:
		RefList<sciFeature> *featureList;
};


#endif //_scibtngp