#include "os.h"
#include "scimotn.h"
#include "sciactor.h"
#include "scigame.h"
#include "sciscrip.h"
#include "game.h"

sciMotion::sciMotion(sciScript *newCaller)
	{
	client = NULL;
	caller = newCaller;
	inMotion = FALSE;
	SetTarget(0, 0);
	}

sciMotion::~sciMotion()
	{
	}

void sciMotion::Doit()
	{
	POINT p;

	if (!inMotion)
		return;

	if (abs(game->GetTime() - moveCnt) >= client->moveSpeed)
		{
		moveCnt = game->GetTime();
		if (inMotion)
			{
			fX += fXDelta;
			fY += fYDelta;
			p.x = (int)fX;
			p.y = (int)fY;
			client->Posn(p.x, p.y);
			if(abs(p.x - targetX) < 5 && abs(p.y - targetY) < 5)
				{
				MotionDone();
				}
			}
		}
	}

void sciMotion::MotionDone()
	{
	if (caller)
		caller->SetTicks(0);
	inMotion = FALSE;
	client->Posn(targetX, targetY);
	}

void sciMotion::SetTarget(int newTargetX, int newTargetY)
	{
	targetX = newTargetX;
	targetY = newTargetY;
	}

void sciMotion::Init(sciActor *newClient)
	{
	int numSteps;

	client = newClient;
	inMotion = TRUE;
	fX = (float)client->GetX();
	fY = (float)client->GetY();
	fXDelta = (targetX - fX);
	fYDelta = (targetY - fY);
	numSteps = (int)((int)((abs((int)fXDelta)<abs((int)fYDelta)) ? abs((int)fYDelta) : abs((int)fXDelta)) / 25);
	if (numSteps == 0)
		numSteps = 1;
	if (client->moveSpeed == 0)
		numSteps = 1; // "snap" motion when speed is 0
	fXDelta /= numSteps;
	fYDelta /= numSteps;
	moveCnt = game->GetTime();
	}

sciMoveTo::sciMoveTo(sciScript *newCaller, int newTargetX, int newTargetY)
	:sciMotion(newCaller)
	{
	SetTarget(newTargetX, newTargetY);
	}

sciMoveTo::~sciMoveTo()
	{
	}
