#include "os.h"
#include "scisound.h"
#include "sciscrip.h"
#include "app.h"
#include "sounder.h"

extern Application *pApp;

sciSound::sciSound(ResourceManager *newResourceManager)
	{
	volume = 127;
	number = -1;
	talkingSound = FALSE;
	if (newResourceManager)
		resourceManager = newResourceManager;
	else
		resourceManager = pApp->pResourceManager;
	loop = 0;
	}

sciSound::~sciSound()
	{
	}

void sciSound::Emit(SoundEmitter * poSoundEmitter, int newNumber, int volume, int SoundPriority, sciScript *whoToCue)
{
	int t;
	//assert(0);
	if (newNumber != -1)
		SetNumber(newNumber);
	if (volume == -1)
		volume = 127;
	if (talkingSound)
	{
		t = 0; 
		pApp->pSoundManager->EmitFromObject(poSoundEmitter, newNumber, SoundPriority, FALSE, volume);
	}
	if (whoToCue)
		whoToCue->SetTicks(t);

	// Turn looping back off.
	loop = 0;
}

void sciSound::Play(int newNumber, int volume, int SoundPriority, sciScript *whoToCue)
	{
	int t;
   //assert(0);
	if (newNumber != -1)
		SetNumber(newNumber);
	if (volume == -1)
		volume = 127;
	if (talkingSound)
   {
		t = 0; 
      pApp->pSoundManager->Play(newNumber, volume, SoundPriority, 0);
   }
	if (whoToCue)
		whoToCue->SetTicks(t);

	// Turn looping back off.
	loop = 0;
	}

void sciSound::SetNumber(int newNumber)
	{
	number = newNumber;
	}

void sciSound::Stop()
	{
   assert(0);
	//pApp->pSoundMana->EndSound();
	}

void sciSound::SetLoop(int newLoop)
	{
	loop = newLoop;
	}
