// string.cpp -- string objects
//
// DJM

#include "stringob.h"
#include <assert.h>

String::String(String &str)
{
	mlSize = str.mlSize;
	mpstr = new char[mlSize + 1];
	strcpy(mpstr, str.mpstr);
}

String::String(const char *pIn)
{
	assert(pIn);

	mlSize = strlen(pIn);
	mpstr = new char[mlSize + 1];
	strcpy(mpstr, pIn);
}

String::String(String *pso)
{
	assert(pso);

	mlSize = pso->mlSize;
	mpstr = new char[mlSize + 1];
	strcpy(mpstr, pso->mpstr);
}

String::String()
{
	mpstr = NULL;
	mlSize = 0;
}

String::String(long lSize, char c)
{
	mlSize = lSize;
	mpstr = new char[mlSize + 1];
	while(lSize--) {
		mpstr[lSize] = c;
	}
	mpstr[mlSize] = '\0';
}

String::~String()
{
	if (mpstr) {
		delete [] mpstr;
	}
}

void String::vSetString(const char *pstr)
{
	assert(pstr);
	vRealloc(strlen(pstr));
	strcpy(mpstr, pstr);
}

void String::vCat(const char *pstr)
{
	assert(pstr);

	long lOldSize = mlSize;
	long lAddSize = strlen(pstr);
	vResize(mlSize + lAddSize);
	memcpy(mpstr + lOldSize, pstr, lAddSize);
	mpstr[mlSize] = '\0';
}

void String::vRealloc(long lNewSize)
{
	if (mpstr) {
		delete [] mpstr;
	}
	mlSize = lNewSize;
	mpstr = new char[mlSize + 1];
	//memset(mpstr, '\0', lNewSize + 1);
}

void String::vResize(long lNewSize)
{
	char *pNew = new char[lNewSize + 1];

	if (mpstr) {
		strncpy(pNew, mpstr, lNewSize);
		pNew[lNewSize] = '\0';
		delete [] mpstr;
	}

	// if there was no mpstr to begin with, mpstr is now garbage
	mpstr = pNew;
	mlSize = lNewSize;
}

