#ifndef _vwindow
#define _vwindow

#include "object.h"
#include "scievent.h"
#include "list.h"

class Bitmap;
class sciPlane;

typedef enum {
	UA_LEFTBUTTONDOWN,
	UA_LEFTBUTTONUP,
	UA_RIGHTBUTTONDOWN,
	UA_RIGHTBUTTONUP,
	UA_MOUSEMOVE,
	UA_CHARACTER
	} USER_ACTIONS;

typedef enum {
	KS_SHIFT	= 0x0001,
	KS_ALT		= 0x0002,
	KS_CONTROL	= 0x0004,
	} KEY_STATES;

class VWindow : public Object {
	public:
		VWindow();
		virtual ~VWindow();
		virtual void MakeWindow(int nWidth = 640, int nHeight = 480);
		virtual void Show();
		virtual void Hide();
		
		virtual void Paint(RECT &rcPaint);
		virtual void Erase(RECT &rcPaint) = 0;
		void Update(RECT &rect);
		void OffscreenUpdate(RECT &rect);
		void OffscreenErase(RECT &rect);
	
		WORD Width();
		WORD Height();

		void vAddPlane(sciPlane *poPlane);
		void vDeletePlane(sciPlane *poPlane);
		int  nGetHighPriority();

		virtual void Doit();

		virtual Boolean HandleEvent(sciEvent &event);

		// event handlers
		void vAddEventHog(Object *poHandler) {moEventHogs.AddToFront(poHandler);};
		void vRemoveEventHog(Object *poHandler) {moEventHogs.Remove(poHandler);};
		void vAddGlobalHandler(Object *poHandler) {moGlobalHandlers.AddToFront(poHandler);};
		void vRemoveGlobalHandler(Object *poHandler) {moGlobalHandlers.Remove(poHandler);};
		void vAddKeyHandler(Object *poHandler) {moKeyHandlers.AddToFront(poHandler);};
		void vRemoveKeyHandler(Object *poHandler) {moKeyHandlers.Remove(poHandler);};

		List<sciPlane>	moPlanes; // a list of the planes, in back-to-front order

		RECT rcOuter, rcInner;
		//Bitmap *pBackgroundBitmap;
		Bitmap *pWorkBitmap;
		//sciPlane *plane;
		int x, y;

	protected:
		BOOL dirty;
		RECT dirtyRect;

		// special event handlers
		RefList<Object> moEventHogs;
		RefList<Object> moGlobalHandlers;
		RefList<Object> moKeyHandlers;
	};

#endif
