// WALKER.H -- the object that handles/manages the various bitmaps for walking, running, fidgeting, attacking, etc
//
// TW
//

#include "walker.h"
#include "vampire.h"

WalkerDB goWalkerDB;
Bitmap *goWalk;

Walker::Walker(Unit *poUnit, int nTemplateID)
{
	assert(poUnit);

	mnTemplateID = nTemplateID;

	mnNormal = poUnit->poTemplate()->lGetValue(TAG_Bnor,0);
	mnCloaked = poUnit->poTemplate()->lGetValue(TAG_Bclk,0);
/*
	mnWalk = poUnit->poTemplate()->lGetValue(TAG_Bnor,0);
	mnWalkOther = poUnit->poTemplate()->lGetValue(TAG_Bclk,0);
	mnRun = poUnit->poTemplate()->lGetValue(TAG_Brun,0);
	mnAttack = poUnit->poTemplate()->lGetValue(TAG_Batt,0);
	mnReact = poUnit->poTemplate()->lGetValue(TAG_Brea,0);
	mnFeed = poUnit->poTemplate()->lGetValue(TAG_Bfee,0);
	mnCast = poUnit->poTemplate()->lGetValue(TAG_Bcas,0);
	mnDie = poUnit->poTemplate()->lGetValue(TAG_Bded,0);
	mnFidgetCloaked = poUnit->poTemplate()->lGetValue(TAG_Bfic,0);
	mnFidgetUncloaked = poUnit->poTemplate()->lGetValue(TAG_Bfiu,0);
	mnFidgetCloakedOther = poUnit->poTemplate()->lGetValue(TAG_Bfco,0);
*/

	
	//clear out arrays
	for (int i = 0; i < NUM_DIRECTIONS; ++i) 
	{
		mapoWalk[i] = NULL;
		mapoWalkOther[i] = NULL;
		mapoRun[i] = NULL;
		mapoAttack[i] = NULL;
		mapoReact[i] = NULL;
		mapoFeed[i] = NULL;
		mapoCast[i] = NULL;
		mapoDie[i] = NULL;
		mapoFidgetCloaked[i] = NULL;
		mapoFidgetUncloaked[i] = NULL;
		mapoFidgetCloakedOther[i] = NULL;
		mapoSpecial[i]=NULL;
	}

	vInitArrays(poUnit);
}

Walker::~Walker()
{

}

//TBD - remove ** lines once nathan gives me attack and react animations for peasants

void Walker::vInitArrays(Unit *poUnit)
{
	//first load the bitmaps that every unit will have
	for (int i = 0; i < NUM_DIRECTIONS; ++i) 
	{
 		mapoWalk[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_WALK) * 10) + i,1);
//**		mapoAttack[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_ATTACK) * 10) + i,1);
//**		mapoReact[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_REACT) * 10) + i,1);
		mapoDie[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_DIE) * 10) + i,1);
		mapoFidgetCloaked[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_FIDGET_C) * 10) + i,1);
		mapoAttack[i] = mapoFidgetCloaked[i];	//** - delete me once animations in
		mapoReact[i] = mapoFidgetCloaked[i];	//** - delete me once animations in

		//now do unit specific
		switch (poUnit->eUnitType())
		{
		case UT_VAMPIRE:
			mapoWalkOther[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnCloaked + OFF_WALK) * 10) + i,1);
			mapoRun[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_RUN) * 10) + i,1);
			mapoFeed[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_FEED) * 10) + i,1);
			mapoFidgetCloakedOther[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnCloaked + OFF_FIDGET_C) * 10) + i,1);
			mapoFidgetUncloaked[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_FIDGET_U) * 10) + i,1);
			mapoCast[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_CAST) * 10) + i,1);
			break;
		case UT_VAMPIREHUNTER:
			mapoRun[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_RUN) * 10) + i,1);
			//maybe feed - Don's not sure yet
			//mapoFeed[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_FEED) * 10) + i,1);
			mapoCast[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_CAST) * 10) + i,1);
			break;
//			uncomment when revenats get put in
//		case UT_REVENANT:
//			mapoSpecial[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_SPECIAL) * 10) + i,1);
//			break;
		default: //rest of units: peasants, merchants, soldier, gypsy, etc
			mapoRun[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_RUN) * 10) + i,1);
			mapoFeed[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, ((mnNormal + OFF_FEED) * 10) + i,1);
		}
	
	}
	goWalk = mapoWalk[2];
/*	if (mnWalk) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoWalk[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnWalk * 10 + i);
	}

	if (mnWalkOther) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoWalkOther[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnWalkOther * 10 + i);
	}

	if (mnRun) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoRun[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnRun * 10 + i);
	}

	if (mnAttack) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoAttack[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnAttack * 10 + i);
	}
	
	if (mnReact) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoReact[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnReact * 10 + i);
	}
	
	if (mnFeed) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoFeed[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnFeed * 10 + i);
	}
	
	if (mnCast) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoCast[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnCast * 10 + i);
	}
	
	if (mnDie) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoDie[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnDie * 10 + i);
	}

	if (mnFidgetCloaked) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoFidgetCloaked[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnFidgetCloaked * 10 + i);
	}

	if (mnFidgetUncloaked) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoFidgetUncloaked[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnFidgetUncloaked * 10 + i);
	}

	if (mnFidgetCloakedOther) 
	{
		for (int i = 0; i < NUM_DIRECTIONS; ++i) 
 			mapoFidgetCloakedOther[i] = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, mnFidgetCloakedOther * 10 + i);
	}
*/
}

void Walker::vAnimationCycle()
{
}


void Walker::vPause()
{
}


Bitmap *Walker::poGetBitmap(Unit *poUnit, DIRECTION eDir)
{
	Boolean bFlip = FALSE;
	Bitmap *poBitmap = NULL;

	if (eDir > D_NORTH)
		bFlip = TRUE;
	
	if (eDir == D_NORTHEAST) 
		eDir = D_NORTHWEST;
	if (eDir == D_EAST) 
		eDir = D_WEST;
	if (eDir == D_SOUTHEAST) 
		eDir = D_SOUTHWEST;


	switch (poUnit->eAction())
	{
	case ACT_WALK:
		if (poUnit->bIsVampire() && !((Vampire*)poUnit)->bMarked(game->poLocalPlayer()->mnPlayer))
			//return mapoWalkOther[eDir];
			poBitmap = mapoWalkOther[eDir];
		else
			//return mapoWalk[eDir];
			poBitmap = mapoWalk[eDir];
		break;
	case ACT_RUN:
		//return mapoRun[eDir];
		poBitmap = mapoRun[eDir];
		break;
	case ACT_ATTACK:
		//return mapoAttack[eDir];
		poBitmap = mapoAttack[eDir];
		break;
	case ACT_REACT:
		//return mapoReact[eDir];
		poBitmap = mapoReact[eDir];
		break;
	case ACT_FEED:
		//return mapoFeed[eDir];
		poBitmap = mapoFeed[eDir];
		break;
	case ACT_CAST:
		//return mapoCast[eDir];
		poBitmap = mapoCast[eDir];
		break;
	case ACT_DIE:
		//return mapoDie[eDir];
		poBitmap = mapoDie[eDir];
		break;
	case ACT_FIDGET_CLOAKED:
//		if (poUnit->poOwner() != game->poLocalPlayer())
		if (poUnit->bIsVampire() && !((Vampire*)poUnit)->bMarked(game->poLocalPlayer()->mnPlayer))
			//return mapoFidgetCloakedOther[eDir];	//others see you fidgeting in cloak mode
			poBitmap = mapoFidgetCloakedOther[eDir];	//others see you fidgeting in cloak mode
		else
			//return mapoFidgetCloaked[eDir];			//you see yourself fidgeting in cloak mode
			poBitmap = mapoFidgetCloaked[eDir];			//you see yourself fidgeting in cloak mode
		break;
	case ACT_FIDGET_UNCLOAKED:
		//return mapoFidgetUncloaked[eDir];
		poBitmap = mapoFidgetUncloaked[eDir];
		break;
	default:
		assert(0); //we should never get here, important Bxxx info is missing from templates
		//return mapoFidgetCloaked[eDir];
		poBitmap = mapoFidgetCloaked[eDir];
		break;
	}
	assert(poBitmap);
	poUnit->vSetFlip(bFlip);
	return poBitmap;
}






WalkerDB::WalkerDB()
{

}
WalkerDB::~WalkerDB()
{
}

Walker *WalkerDB::poAddObject(Unit *poUnit, int nTemplateID)
{
	int i;
	Walker *poWalker;
	int nSize = moObjects.GetSize();

	assert(poUnit);

	for (i = 0; i < nSize; ++i) 
	{
		poWalker = moObjects.GetItem(i);
		assert(poWalker);
		if (poWalker->bIsSame(nTemplateID))
			return poWalker;
	}

	//walker not in list so needs to be created
	poWalker = new Walker(poUnit, nTemplateID);
	moObjects.AddToEnd(poWalker);
//	vDebugOut("SIZE:%d\n", moObjects.GetSize());
	return poWalker;
}
